Unit sf18e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF17E_p, UTSF11_p;

procedure sf18e(X :Extended; var BER1 :Extended; var BEI1 :Extended;
                var AKER1 :Extended; var AKEI1 :Extended;
                var IERR :Integer);

implementation

procedure sf18e(X :Extended; var BER1 :Extended; var BEI1 :Extended;
                var AKER1 :Extended; var AKEI1 :Extended;
                var IERR :Integer);
var
BERP,BEIP,XKEIP,XKERP :Extended;
const
SYS059 :Real = 1.7E308;
SYS029 :Real = 0.70710678118654752440084436210485;
ZERO :Real = 0.0e0;
ZMAX :Real = 119.0e0;
label
_1,_2,_3,_4,_5;
begin
IERR := 0;
if ( X = ZERO ) 
 then goto _3;
if ( Abs(X) > ZMAX ) 
 then goto _2;
SF17E(X,BERP,BEIP,XKERP,XKEIP,IERR);
BEI1 := (BERP+BEIP)*SYS029;
BER1 := (BERP-BEIP)*SYS029;
if ( X < ZERO ) 
 then goto _1;
AKEI1 := (XKERP+XKEIP)*SYS029;
AKER1 := (XKERP-XKEIP)*SYS029;
goto _5;
_1:
AKER1 := SYS059;
AKEI1 := SYS059;
IERR := 1;
goto _4;
_2:
BEI1 := ZERO;
BER1 := ZERO;
AKER1 := ZERO;
AKEI1 := ZERO;
IERR := 66;
if ( X > ZERO ) 
 then goto _4;
AKER1 := SYS059;
AKEI1 := SYS059;
goto _4;
_3:
BEI1 := ZERO;
BER1 := ZERO;
AKER1 := -SYS059;
AKEI1 := -SYS059;
goto _5;
_4:
UTSF11(IERR,18);
_5:
end;

end.
